> ## Documentation Index
> Fetch the complete documentation index at: https://docs.yapily.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Get Account Direct Debits

> Returns the list of direct debits for an account.

Feature: `ACCOUNT_DIRECT_DEBITS`

<Info>Learn more: [Data Access Restrictions](/data/financial-data-resources/data-restrictions#uk-banks)</Info>


## OpenAPI

````yaml /openapi-converted.json get /accounts/{accountId}/direct-debits
openapi: 3.0.1
info:
  description: >-
    The Yapily API enables connections between your application and users'
    banks. For more information check out our [documentation](/introduction).


    In particular, make sure to view our [Getting
    Started](/getting-started/get-started) steps if this is your first time
    here.


    While testing the API, our list of [sandbox
    credentials](/resources/sandbox/sandbox-credentials) maybe useful.
  title: Yapily API
  version: 12.3.4
  contact:
    name: Yapily Support
    url: https://docs.yapily.com/resources/support
    email: support@yapily.com
servers:
  - url: https://api.yapily.com
security:
  - basicAuth: []
tags:
  - description: >-
      The `Application` is the base entity that is used to interact with the API
      and contains a collection of `Institution` objects. You can have multiple
      Applications associated with your account e.g. a production application
      with live access to each `Institution` and a development application with
      access to sandboxes.
    name: Application
  - description: >-
      The Users endpoints are used to manage each user (otherwise known as the
      PSU) in Yapily. Each user belongs to an Application and as a consequence,
      so do each `Consent` created for a particular `User`.
    name: Users
  - description: >-
      An `Institution` object represents any Account Serving Payment Servicing
      Provider (ASPSP) that has been integrated and is accessible through the
      Yapily APIs (ASPSPs are entities that publish Read/Write APIs to permit,
      with customer consent, payments initiated by third party providers and/or
      make their customers financial data available to third party providers via
      their API endpoints).


      Any one of the following would be represented as Institution:


      - Traditional banks e.g. Santander

      - Neo-banks e.g. Monzo

      - Building societies e.g. Cumberland Building Society
    name: Institutions
  - description: >-
      The Consents endpoints are used to manage each `Consent` created by Yapily
      in response to an authorisation created for a user.


      The `Consent` object contains data that identifies a user's consent for a
      specific `Institution` within a Yapily application. Other than the id of
      the consent, the `institution-id` for the corresponding `Institution` and
      the user identifiers (`user-uuid` and `application-user-id`), it contains
      various details that indicates how the `Consent` can be used.
    name: Consents
  - description: >-
      Before calling [Financial Data](#yapily-api-financial-data) or
      [Payments](#yapily-api-payments) endpoints, a consent from an end-user
      must be obtained.


      Consents are valid for up to 90 days for Financial Data endpoints and have
      a single-use for Payment endpoints i.e. a new consent must be obtained for
      each payment.


      NOTE: A user consent is also referred to as an 'Authorisation'.
    name: Authorisations
  - description: >-
      In order to access a user's Financial Data, you are required to request an
      [Authorisation](#tag/Authorisations) from the user to share the account
      information the bank has. Once a `consent-token` is obtained, you can call
      the necessary Financial Data endpoint(s) to retrieve the user's data.
    name: Financial Data
  - description: >-
      In order to make a Payment on behalf of a user, you are required to
      request an [Authorisation](#tag/Authorisations) from the user to authorise
      the user's account to make the payment from. Once a `consent-token` is
      obtained, you can call the necessary Payments endpoint(s) to execute a
      payment.
    name: Payments
  - description: >+
      The Notifications endpoints provide an interactive way for user to receive
      notifications according to different event-types. This feature is
      currently in private beta. Please reach out if you require access. 

    name: Notifications
  - description: >-
      Variable Recurring Payments enables transfer of money between accounts
      held by the same person or transfer of money for business payments. 


      In order to make Sweeping Variable Recurring Payments on behalf of a user,
      you are required to request an [Consent](#tag/Authorisations) from the
      user by calling the Sweeping Consent endpoint to authorise the user's
      account to make the payment. Once a `consent-token` is obtained, you can
      call the Payments endpoint to execute the Sweeping Variable Recurring
      Payments transaction. Before executing the payment, you have the option to
      confirm availability of funds in the user's account by calling the Funds
      Confirmation endpoint. 


      See [VRP Payments](/payments/vrps/additional-information) for more
      information.
    name: Variable Recurring Payments
  - description: Hosted Payment Pages endpoints for payments products
    name: Hosted Payment Pages
  - description: Hosted Consent Pages endpoints for data products
    name: Hosted Consent Pages
  - description: >-
      The constraints endpoints can be used to retrieve institution specific
      data requirements and rules that will apply when performing other
      operations.
    name: Constraints
  - description: >-
      Application Management endpoints help with creating and managing client
      sub-applications.
    name: Application Management
  - description: 'Data Plus endpoints enable our customers to enrich transaction data. '
    name: Data Plus
  - description: Webhook endpoints
    name: Webhooks
  - description: Application Beneficiaries Endpoints
    name: Application Beneficiaries
  - description: User Beneficiaries Endpoints
    name: User Beneficiaries
paths:
  /accounts/{accountId}/direct-debits:
    get:
      tags:
        - Financial Data
      summary: Get Account Direct Debits
      description: |-
        Returns the list of direct debits for an account.

        Feature: `ACCOUNT_DIRECT_DEBITS`
      operationId: getAccountDirectDebits
      parameters:
        - description: __Mandatory__. The account Id of the user's bank account.
          in: path
          name: accountId
          required: true
          schema:
            type: string
        - description: >-
            __Mandatory__. The `consent-token` containing the user's
            authorisation to make the request.
          example: '{consentToken}'
          in: header
          name: consent
          required: true
          schema:
            type: string
        - $ref: '#/components/parameters/SubAppHeader'
        - description: >-
            __Optional__. The maximum number of transaction records to be
            returned. Must be between 1 and 1000.
          in: query
          name: limit
          required: false
          schema:
            type: integer
            format: int32
      responses:
        '200':
          content:
            application/json;charset=UTF-8:
              examples:
                OBIE Example Response:
                  $ref: >-
                    #/components/examples/obie-example-acc-direct-debits-response
              schema:
                $ref: '#/components/schemas/ApiListResponseOfDirectDebitResponse'
          description: Ok
        default:
          content:
            application/json;charset=UTF-8:
              examples:
                Error Response:
                  $ref: '#/components/examples/error-response-code-401'
              schema:
                $ref: '#/components/schemas/ApiResponseError'
          description: Error Response
components:
  parameters:
    SubAppHeader:
      description: The sub-application ID to which event type is being subscribed to
      in: header
      name: sub-application
      required: false
      schema:
        type: string
        format: uuid
  examples:
    obie-example-acc-direct-debits-response:
      description: OBIE Example Response
      value:
        meta:
          tracingId: c2dec674a3fb402e8543129565491244
          count: 2
          pagination:
            totalCount: 2
            self:
              limit: 1000
        data:
          - id: '700009000000000000000076'
            statusDetails:
              status: INACTIVE
            payeeDetails:
              name: EDF ENERGY
            reference: '671018097704'
            previousPaymentAmount:
              amount: 145
              currency: GBP
            previousPaymentDateTime: '2016-10-05T00:00:00Z'
          - id: '700009000000000000000038'
            statusDetails:
              status: ACTIVE
            payeeDetails:
              name: SANTANDER MORTGAGE
            reference: '40118272'
            previousPaymentAmount:
              amount: 1000
              currency: GBP
            previousPaymentDateTime: '2017-12-01T00:00:00Z'
        links:
          self: >-
            https://api.yapily.com/accounts/700004000000000000000002/direct-debits?limit=1000
    error-response-code-401:
      description: Error Response
      value:
        error:
          code: 401
          status: UNAUTHORIZED
          message: Full authentication is required to access this resource
  schemas:
    ApiListResponseOfDirectDebitResponse:
      type: object
      properties:
        meta:
          $ref: '#/components/schemas/ResponseListMeta'
        data:
          type: array
          items:
            $ref: '#/components/schemas/DirectDebitResponse'
        links:
          type: object
          additionalProperties:
            type: string
        forwardedData:
          type: array
          items:
            $ref: '#/components/schemas/ResponseForwardedData'
        raw:
          deprecated: true
          type: array
          items:
            $ref: '#/components/schemas/RawResponse'
        paging:
          $ref: '#/components/schemas/FilteredClientPayloadListDirectDebitResponse'
        tracingId:
          type: string
          writeOnly: true
    ApiResponseError:
      type: object
      properties:
        error:
          $ref: '#/components/schemas/ApiError'
        raw:
          deprecated: true
          type: array
          items:
            $ref: '#/components/schemas/RawResponse'
      description: >-
        Used to return errors from the bank from each request


        - `400` - Returned by any `POST` endpoint when the body does not conform
        to the contract

        - `401` - Returned by any endpoint when an invalid `authToken` is used
        for authentication

        - `403` - Returned by any [Financial
        Data](/api-reference#financial-data) and any
        [Payments](/api-reference#payments) endpoint when the `Consent` is no
        longer authorised to access financial data or to make a payment

        - `404` - Returned by any endpoint where there are path parameters and
        the path parameters supplied are unable to find the desired resource

        - `409` - Returned by any `POST` endpoint when creating a resource that
        conflicts with any other existing resource e.g. [Create
        User](/api-reference/addUser)

        - `424` - Returned by any [Financial
        Data](/api-reference#financial-data) and any
        [Payments](/api-reference#payments) endpoint when the feature to be
        accessed is not supported by the `Institution`.

        - `500` - Returned by any endpoint when Yapily is down. If you encounter
        any false positives, please [notify us](mailto:support@yapily.com)
      example:
        error:
          tracingId: 74b13ce8ed51419f92c5d609e04532de
          code: 424
          institutionError:
            errorMessage: >-
              {"Code":"500 Internal Server
              Error","Id":"5ff8d331-4282-41e0-b5ef-1ac9ac39f009","Message":"Technical
              Error. Please try again
              later","Errors":[{"ErrorCode":"UK.OBIE.UnexpectedError","Message":"There
              was a problem processing your request. Please try again later"}]}
            httpStatusCode: 500
          source: INSTITUTION
          status: FAILED_DEPENDENCY
    ResponseListMeta:
      type: object
      properties:
        tracingId:
          type: string
        count:
          type: integer
          format: int32
        pagination:
          $ref: '#/components/schemas/Pagination'
    DirectDebitResponse:
      type: object
      properties:
        id:
          type: string
        statusDetails:
          $ref: '#/components/schemas/PaymentStatusDetails'
        payeeDetails:
          $ref: '#/components/schemas/DirectDebitPayee'
        reference:
          type: string
        previousPaymentAmount:
          $ref: '#/components/schemas/Amount'
        previousPaymentDateTime:
          type: string
          format: date-time
    ResponseForwardedData:
      type: object
      properties:
        headers:
          type: object
          additionalProperties:
            type: string
        url:
          type: string
    RawResponse:
      deprecated: true
      type: object
      description: >-
        [DEPRECATED] Interaction (raw request and response) that occurred with
        the `Institution` in order to fulfil a request.
      properties:
        request:
          $ref: '#/components/schemas/RawRequest'
        duration:
          type: string
          format: iso8601
        headers:
          type: object
          additionalProperties:
            type: string
        resultCode:
          type: integer
          format: int32
        result:
          type: object
    FilteredClientPayloadListDirectDebitResponse:
      type: object
      properties:
        apiCall:
          $ref: '#/components/schemas/ApiCall'
        data:
          type: array
          items:
            $ref: '#/components/schemas/DirectDebitResponse'
        nextCursorHash:
          type: string
        nextLink:
          type: string
        pagingMap:
          type: object
          additionalProperties:
            $ref: '#/components/schemas/FilterAndSort'
        totalCount:
          type: integer
          format: int64
    ApiError:
      type: object
      description: Provides details of the error that has occurred.
      properties:
        code:
          type: integer
          description: __Mandatory__. Numeric `HTTP` status code associated with the error.
          format: int32
        institutionError:
          $ref: '#/components/schemas/InstitutionError'
        message:
          type: string
          description: >-
            __Mandatory__. Description of the exact error that has been
            experienced.
        source:
          type: string
        status:
          type: string
          description: __Mandatory__. Textual description of the `HTTP` error status type.
        tracingId:
          type: string
          description: >-
            __Optional__.  A unique identifier assigned by Yapily for the
            request that can be used for support purposes.
    Pagination:
      type: object
      properties:
        totalCount:
          type: integer
          format: int64
        self:
          $ref: '#/components/schemas/FilterAndSort'
        next:
          $ref: '#/components/schemas/Next'
    PaymentStatusDetails:
      type: object
      properties:
        status:
          $ref: '#/components/schemas/PaymentStatus'
        statusReason:
          type: string
        statusReasonDescription:
          type: string
        statusUpdateDate:
          type: string
          format: date-time
        multiAuthorisationStatus:
          $ref: '#/components/schemas/MultiAuthorisation'
        isoStatus:
          $ref: '#/components/schemas/PaymentIsoStatus'
    DirectDebitPayee:
      type: object
      properties:
        name:
          type: string
          description: __Mandatory__. The account holder name.
          example: Tempus Risus Company
    Amount:
      title: Amount Details
      required:
        - amount
        - currency
      type: object
      properties:
        amount:
          title: Amount
          type: number
          description: __Mandatory__. The monetary value
          example: 10
        currency:
          title: Currency
          type: string
          description: >-
            __Mandatory__. The [ISO 4217](https://www.xe.com/iso4217.php)
            currency code
          example: GBP
      description: __Mandatory__. Monetary Amount.
    RawRequest:
      type: object
      properties:
        method:
          type: string
        url:
          type: string
        requestInstant:
          type: string
          format: date-time
        headers:
          type: object
          additionalProperties:
            type: string
        body:
          type: object
        bodyParameters:
          type: object
          additionalProperties:
            type: string
        startTime:
          type: string
          format: date-time
        startedAt:
          type: string
          format: date-time
          deprecated: true
    ApiCall:
      type: object
    FilterAndSort:
      type: object
      properties:
        from:
          type: string
          description: >-
            __Optional__. The earliest date and time of resources / records that
            should be returned.
          format: date-time
        before:
          type: string
          description: >-
            __Optional__. The latest date and time of resources / records that
            should be returned.
          format: date-time
        limit:
          type: integer
          description: >-
            __Optional__. The maximum number of resources / records that should
            be returned.
          format: int32
        sort:
          $ref: '#/components/schemas/SortEnum'
        offset:
          type: integer
          format: int32
        cursor:
          type: string
    InstitutionError:
      type: object
      description: >-
        Raw error details provided by the `Institution`, when it was the error
        source.
      properties:
        errorMessage:
          type: string
          description: Textual description of the `Institution` error.
        httpStatusCode:
          type: integer
          description: Numeric HTTP status code associated with the `Institution` error.
          format: int32
    Next:
      type: object
      properties:
        from:
          type: string
          format: date-time
        before:
          type: string
          format: date-time
        limit:
          type: integer
          format: int32
        cursor:
          type: string
    PaymentStatus:
      type: string
      description: >-
        The status of the Payment. 


        For more information, see [Payment
        Status](/guides/payments/payment-status/)
      enum:
        - PENDING
        - FAILED
        - DECLINED
        - COMPLETED
        - COMPLETED_SETTLEMENT_IN_PROCESS
        - EXPIRED
        - UNKNOWN
        - ACTIVE
        - INACTIVE
    MultiAuthorisation:
      type: object
      description: >-
        Details the additional levels of authorisation which are required from,
        and being managed by, the `Institution`.
      properties:
        status:
          type: string
          description: >-
            __Mandatory__. Specifies the current status of the
            multi-authorisation flow.
        numberOfAuthorisationRequired:
          type: integer
          description: __Mandatory__. Total number of authorisations required.
          format: int32
        numberOfAuthorisationReceived:
          type: integer
          description: >-
            __Mandatory__. The total number of authorisations that have been
            received.
          format: int32
        lastUpdatedDateTime:
          type: string
          description: >-
            __Mandatory__. Date and time of when the authorisation was last
            updated.
          format: date-time
        expirationDateTime:
          type: string
          description: >-
            __Mandatory__. Date and time by when the authorisation flow must be
            completed before it expires and the authorisation request is
            terminated.
          format: date-time
    PaymentIsoStatus:
      type: object
      description: The payment status code, as denoted by a 3-letter ISO 20022 code.
      properties:
        code:
          $ref: '#/components/schemas/PaymentIsoStatusCodeEnum'
        name:
          type: string
          description: The full name of the ISO 20022 `PaymentStatusCode`.
          example: AcceptedCreditSettlementCompleted
    SortEnum:
      type: string
      description: >-
        The attribute on which resources / records returned should be sorted.
        Valid options for the sort parameter.
      enum:
        - date
        - '-date'
    PaymentIsoStatusCodeEnum:
      type: string
      description: The ISO 20022 `PaymentStatusCode`.
      example: ACCC
      enum:
        - ACCC
        - ACCP
        - ACSC
        - ACSP
        - ACTC
        - ACWC
        - ACWP
        - RCVD
        - PDNG
        - RJCT
        - CANC
        - ACFC
        - PATC
        - PART
        - ACCO
  securitySchemes:
    basicAuth:
      description: >-
        Use HTTP Basic Authentication with your Application ID as username and
        Application Secret as password. Manage credentials in the [Yapily
        Console](https://console.yapily.com/). See
        [Authentication](/api-reference/authentication) for details.
      scheme: basic
      type: http

````